Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 1014)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 1015)
@@ -3584,3 +4459,281 @@
     END SUBROUTINE advec_w_ws
 
+
+!------------------------------------------------------------------------------!
+! Advection of w - Call for all grid points - accelerator version
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_w_ws_acc
+
+       USE arrays_3d
+       USE constants
+       USE control_parameters
+       USE grid_variables
+       USE indices
+       USE statistics
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, ibit27, ibit28, ibit29, ibit30, ibit31, ibit32, ibit33, &
+                   ibit34, ibit35, j, k, k_mmm, k_mm, k_pp, k_ppp, tn = 0
+
+       REAL    ::  diss_d, diss_l, diss_n, diss_r, diss_s, diss_t, div,    &
+                   flux_d, flux_l, flux_n, flux_r, flux_s, flux_t, gu, gv, &
+                   u_comp, u_comp_l, v_comp, v_comp_s, w_comp
+
+       gu = 2.0 * u_gtrans
+       gv = 2.0 * v_gtrans
+
+!
+!--    Computation of fluxes and tendency terms
+       !$acc kernels present( ddzu, tend, u, v, w, wall_flags_0 )
+       !$acc loop
+       DO i = nxl, nxr
+          DO  j = nys, nyn
+             !$acc loop vector( 32 )
+             DO  k = nzb+1, nzt
+
+                ibit29 = IBITS(wall_flags_0(k,j,i),29,1)
+                ibit28 = IBITS(wall_flags_0(k,j,i),28,1)
+                ibit27 = IBITS(wall_flags_0(k,j,i),27,1)
+
+
+                u_comp_l                 = u(k+1,j,i) + u(k,j,i) - gu
+                flux_l                   = u_comp_l * (                        &
+                                      ( 37.0 * ibit29 * adv_mom_5              &
+                                   +     7.0 * ibit28 * adv_mom_3              &
+                                   +           ibit27 * adv_mom_1              &
+                                      ) *                                      &
+                                     ( w(k,j,i)   + w(k,j,i-1) )               &
+                               -      (  8.0 * ibit29 * adv_mom_5              &
+                                   +           ibit28 * adv_mom_3              &
+                                      ) *                                      &
+                                     ( w(k,j,i+1) + w(k,j,i-2) )               &
+                               +      (        ibit29 * adv_mom_5              &
+                                      ) *                                      &
+                                     ( w(k,j,i+2) + w(k,j,i-3) )               &
+                                                 )
+
+                diss_l                    = - ABS( u_comp_l ) * (              &
+                                        ( 10.0 * ibit29 * adv_mom_5            &
+                                     +     3.0 * ibit28 * adv_mom_3            &
+                                     +           ibit27 * adv_mom_1            &
+                                        ) *                                    &
+                                     ( w(k,j,i)   - w(k,j,i-1) )               &
+                                 -      (  5.0 * ibit29 * adv_mom_5            &
+                                     +           ibit28 * adv_mom_3            &
+                                        ) *                                    &
+                                     ( w(k,j,i+1) - w(k,j,i-2) )               &
+                                 +      (        ibit29 * adv_mom_5            &
+                                        ) *                                    &
+                                     ( w(k,j,i+2) - w(k,j,i-3) )               &
+                                                            )
+
+                u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
+                flux_r    = u_comp * (                                       &
+                          ( 37.0 * ibit29 * adv_mom_5                        &
+                       +     7.0 * ibit28 * adv_mom_3                        &
+                       +           ibit27 * adv_mom_1                        &
+                          ) *                                                &
+                                 ( w(k,j,i+1) + w(k,j,i)   )                 &
+                   -      (  8.0 * ibit29 * adv_mom_5                        &
+                       +           ibit28 * adv_mom_3                        &
+                          ) *                                                &
+                                 ( w(k,j,i+2) + w(k,j,i-1) )                 &
+                   +      (        ibit29 * adv_mom_5                        &
+                          ) *                                                &
+                                 ( w(k,j,i+3) + w(k,j,i-2) )                 &
+                                     )
+
+                diss_r    = - ABS( u_comp ) * (                              &
+                          ( 10.0 * ibit29 * adv_mom_5                        &
+                       +     3.0 * ibit28 * adv_mom_3                        &
+                       +           ibit27 * adv_mom_1                        &
+                          ) *                                                &
+                                 ( w(k,j,i+1) - w(k,j,i)  )                  &
+                   -      (  5.0 * ibit29 * adv_mom_5                        &
+                       +           ibit28 * adv_mom_3                        &
+                          ) *                                                &
+                                 ( w(k,j,i+2) - w(k,j,i-1) )                 &
+                   +      (        ibit29 * adv_mom_5                        &
+                          ) *                                                &
+                                 ( w(k,j,i+3) - w(k,j,i-2) )                 &
+                                              )
+
+                ibit32 = IBITS(wall_flags_0(k,j,i),32,1)
+                ibit31 = IBITS(wall_flags_0(k,j,i),31,1)
+                ibit30 = IBITS(wall_flags_0(k,j,i),30,1)
+
+                v_comp_s               = v(k+1,j,i) + v(k,j,i) - gv
+                flux_s                 = v_comp_s * (                         &
+                                    ( 37.0 * ibit32 * adv_mom_5               &
+                                 +     7.0 * ibit31 * adv_mom_3               &
+                                 +           ibit30 * adv_mom_1               &
+                                    ) *                                       &
+                                     ( w(k,j,i)   + w(k,j-1,i) )              &
+                             -      (  8.0 * ibit32 * adv_mom_5               &
+                                 +           ibit31 * adv_mom_3               &
+                                    ) *                                       &
+                                     ( w(k,j+1,i) + w(k,j-2,i) )              &
+                             +      (        ibit32 * adv_mom_5               &
+                                    ) *                                       &
+                                     ( w(k,j+2,i) + w(k,j-3,i) )              &
+                                               )
+
+                diss_s                 = - ABS( v_comp_s ) * (                &
+                                    ( 10.0 * ibit32 * adv_mom_5               &
+                                 +     3.0 * ibit31 * adv_mom_3               &
+                                 +           ibit30 * adv_mom_1               &
+                                    ) *                                       &
+                                     ( w(k,j,i)   - w(k,j-1,i) )              &
+                             -      (  5.0 * ibit32 * adv_mom_5               &
+                                 +           ibit31 * adv_mom_3               &
+                                    ) *                                       &
+                                     ( w(k,j+1,i) - w(k,j-2,i) )              &
+                             +      (        ibit32 * adv_mom_5               &
+                                    ) *                                       &
+                                     ( w(k,j+2,i) - w(k,j-3,i) )              &
+                                                        )
+
+                v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
+                flux_n    = v_comp * (                                       &
+                          ( 37.0 * ibit32 * adv_mom_5                        &
+                       +     7.0 * ibit31 * adv_mom_3                        &
+                       +           ibit30 * adv_mom_1                        &
+                          ) *                                                &
+                                 ( w(k,j+1,i) + w(k,j,i)   )                 &
+                   -      (  8.0 * ibit32 * adv_mom_5                        &
+                       +           ibit31 * adv_mom_3                        &
+                          ) *                                                &
+                                 ( w(k,j+2,i) + w(k,j-1,i) )                 &
+                   +      (        ibit32 * adv_mom_5                        &
+                          ) *                                                &
+                                 ( w(k,j+3,i) + w(k,j-2,i) )                 &
+                                     )
+
+                diss_n    = - ABS( v_comp ) * (                              &
+                          ( 10.0 * ibit32 * adv_mom_5                        &
+                       +     3.0 * ibit31 * adv_mom_3                        &
+                       +           ibit30 * adv_mom_1                        &
+                          ) *                                                &
+                                 ( w(k,j+1,i) - w(k,j,i)  )                  &
+                   -      (  5.0 * ibit32 * adv_mom_5                        &
+                       +           ibit31 * adv_mom_3                        &
+                          ) *                                                &
+                                 ( w(k,j+2,i) - w(k,j-1,i) )                 &
+                   +      (        ibit32 * adv_mom_5                        &
+                          ) *                                                &
+                                 ( w(k,j+3,i) - w(k,j-2,i) )                 &
+                                              )
+
+
+                ibit35 = IBITS(wall_flags_0(k-1,j,i),35,1)
+                ibit34 = IBITS(wall_flags_0(k-1,j,i),34,1)
+                ibit33 = IBITS(wall_flags_0(k-1,j,i),33,1)
+
+                k_pp  = k + 2 * ( 1 - ibit33 )
+                k_mm  = k - 2 * ( 1 - ibit33 )
+                k_mmm = k - 3 * ibit35
+
+                w_comp    = w(k,j,i) + w(k-1,j,i)
+                flux_d    = w_comp  * (                                      &
+                          ( 37.0 * ibit35 * adv_mom_5                        &
+                       +     7.0 * ibit34 * adv_mom_3                        &
+                       +           ibit33 * adv_mom_1                        &
+                          ) *                                                &
+                             ( w(k,j,i)    + w(k-1,j,i)   )                  &
+                   -      (  8.0 * ibit35 * adv_mom_5                        &
+                       +           ibit34 * adv_mom_3                        &
+                          ) *                                                &
+                             ( w(k+1,j,i)  + w(k_mm,j,i)  )                  &
+                   +      (        ibit35 * adv_mom_5                        &
+                          ) *                                                &
+                             ( w(k_pp,j,i) + w(k_mmm,j,i) )                  &
+                                       )
+
+                diss_d    = - ABS( w_comp ) * (                              &
+                          ( 10.0 * ibit35 * adv_mom_5                        &
+                       +     3.0 * ibit34 * adv_mom_3                        &
+                       +           ibit33 * adv_mom_1                        &
+                          ) *                                                &
+                             ( w(k,j,i)    - w(k-1,j,i)   )                  &
+                   -      (  5.0 * ibit35 * adv_mom_5                        &
+                       +           ibit34 * adv_mom_3                        &
+                          ) *                                                &
+                             ( w(k+1,j,i)  - w(k_mm,j,i)  )                  &
+                   +      (        ibit35 * adv_mom_5                        &
+                          ) *                                                &
+                             ( w(k_pp,j,i) - w(k_mmm,j,i) )                  &
+                                               )
+
+!
+!--             k index has to be modified near bottom and top, else array
+!--             subscripts will be exceeded.
+                ibit35 = IBITS(wall_flags_0(k,j,i),35,1)
+                ibit34 = IBITS(wall_flags_0(k,j,i),34,1)
+                ibit33 = IBITS(wall_flags_0(k,j,i),33,1)
+
+                k_ppp = k + 3 * ibit35
+                k_pp  = k + 2 * ( 1 - ibit33  )
+                k_mm  = k - 2 * ibit35
+
+                w_comp    = w(k+1,j,i) + w(k,j,i)
+                flux_t    = w_comp  * (                                      &
+                          ( 37.0 * ibit35 * adv_mom_5                        &
+                       +     7.0 * ibit34 * adv_mom_3                        &
+                       +           ibit33 * adv_mom_1                        &
+                          ) *                                                &
+                             ( w(k+1,j,i)  + w(k,j,i)     )                  &
+                   -      (  8.0 * ibit35 * adv_mom_5                        &
+                       +           ibit34 * adv_mom_3                        &
+                          ) *                                                &
+                             ( w(k_pp,j,i)  + w(k-1,j,i)  )                  &
+                   +      (        ibit35 * adv_mom_5                        &
+                          ) *                                                &
+                             ( w(k_ppp,j,i) + w(k_mm,j,i) )                  &
+                                       )
+
+                diss_t    = - ABS( w_comp ) * (                              &
+                          ( 10.0 * ibit35 * adv_mom_5                        &
+                       +     3.0 * ibit34 * adv_mom_3                        &
+                       +           ibit33 * adv_mom_1                        &
+                          ) *                                                &
+                             ( w(k+1,j,i)   - w(k,j,i)    )                  &
+                   -      (  5.0 * ibit35 * adv_mom_5                        &
+                       +           ibit34 * adv_mom_3                        &
+                          ) *                                                &
+                             ( w(k_pp,j,i)  - w(k-1,j,i)  )                  &
+                   +      (        ibit35 * adv_mom_5                        &
+                          ) *                                                &
+                             ( w(k_ppp,j,i) - w(k_mm,j,i) )                  &
+                                               )
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities caused
+!--             by a not sufficient reduction of divergences near topography.
+                div = ( ( u_comp + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx  &
+                    +   ( v_comp + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy  &
+                    +   ( w_comp      - ( w(k,j,i)   + w(k-1,j,i) ) )        &
+                                                                 * ddzu(k+1) &
+                      ) * 0.5
+
+                tend(k,j,i) = - (                                                &
+                               ( flux_r + diss_r - flux_l - diss_l ) * ddx       &
+                             + ( flux_n + diss_n - flux_s - diss_s ) * ddy       &
+                             + ( flux_t + diss_t - flux_d - diss_d ) * ddzu(k+1) &
+                                 ) + div * w(k,j,i)
+
+
+!++
+!--             Statistical Evaluation of w'w'.
+!                sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                    &
+!                               + ( flux_t + diss_t )                    &
+!                               *   weight_substep(intermediate_timestep_count)
+
+             ENDDO
+          ENDDO
+       ENDDO
+       !$acc end kernels
+
+    END SUBROUTINE advec_w_ws_acc
+
  END MODULE advec_ws
Index: /palm/trunk/SOURCE/buoyancy.f90
===================================================================
--- /palm/trunk/SOURCE/buoyancy.f90	(revision 1014)
+++ /palm/trunk/SOURCE/buoyancy.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Currrent revisions:
 ! -----------------
-!
+! accelerator version (*_acc) added
 !
 ! Former revisions:
@@ -55,5 +55,5 @@
 
     PRIVATE
-    PUBLIC buoyancy, calc_mean_profile
+    PUBLIC buoyancy, buoyancy_acc, calc_mean_profile
 
     INTERFACE buoyancy
@@ -61,4 +61,8 @@
        MODULE PROCEDURE buoyancy_ij
     END INTERFACE buoyancy
+
+    INTERFACE buoyancy_acc
+       MODULE PROCEDURE buoyancy_acc
+    END INTERFACE buoyancy_acc
 
     INTERFACE calc_mean_profile
@@ -164,4 +168,107 @@
 
     END SUBROUTINE buoyancy
+
+
+!------------------------------------------------------------------------------!
+! Call for all grid points - accelerator version
+!------------------------------------------------------------------------------!
+    SUBROUTINE buoyancy_acc( var, var_reference, wind_component, pr )
+
+       USE arrays_3d
+       USE control_parameters
+       USE indices
+       USE pegrid
+       USE statistics
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k, pr, wind_component
+       REAL    ::  var_reference
+#if defined( __nopointer )
+       REAL, DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  var
+#else
+       REAL, DIMENSION(:,:,:), POINTER ::  var
+#endif
+
+
+       IF ( .NOT. sloping_surface )  THEN
+!
+!--       Normal case: horizontal surface
+          IF ( use_reference )  THEN
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_s_inner(j,i)+1, nzt-1
+                      tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5 * &
+                                                            (                  &
+                          ( var(k,j,i)   - hom(k,1,pr,0)   ) / var_reference + &
+                          ( var(k+1,j,i) - hom(k+1,1,pr,0) ) / var_reference   &
+                                                            )
+                   ENDDO
+                ENDDO
+             ENDDO
+          ELSE
+             !$acc kernels present( nzb_s_inner, hom, tend, var )
+             !$acc loop
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   !$acc loop vector(32)
+                   DO  k = 1, nzt-1
+                      IF ( k > nzb_s_inner(j,i) )  THEN
+                         tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5 * &
+                                                               (                  &
+                             ( var(k,j,i)   - hom(k,1,pr,0)   ) / hom(k,1,pr,0) + &
+                             ( var(k+1,j,i) - hom(k+1,1,pr,0) ) / hom(k+1,1,pr,0) &
+                                                               )
+                      ENDIF
+                   ENDDO
+                ENDDO
+             ENDDO
+             !$acc end kernels
+          ENDIF
+
+       ELSE
+!
+!--       Buoyancy term for a surface with a slope in x-direction. The equations
+!--       for both the u and w velocity-component contain proportionate terms.
+!--       Temperature field at time t=0 serves as environmental temperature.
+!--       Reference temperature (pt_surface) is the one at the lower left corner
+!--       of the total domain.
+          IF ( wind_component == 1 )  THEN
+
+             DO  i = nxlu, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_s_inner(j,i)+1, nzt-1
+                      tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *      &
+                           0.5 * ( ( pt(k,j,i-1)         + pt(k,j,i)         ) &
+                                 - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) ) &
+                                 ) / pt_surface
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          ELSEIF ( wind_component == 3 )  THEN
+
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb_s_inner(j,i)+1, nzt-1
+                      tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *      &
+                           0.5 * ( ( pt(k,j,i)         + pt(k+1,j,i)         ) &
+                                 - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) ) &
+                                 ) / pt_surface
+                   ENDDO
+                ENDDO
+            ENDDO
+
+          ELSE
+
+             WRITE( message_string, * ) 'no term for component "',&
+                                       wind_component,'"'
+             CALL message( 'buoyancy', 'PA0159', 1, 2, 0, 6, 0 )
+
+          ENDIF
+
+       ENDIF
+
+    END SUBROUTINE buoyancy_acc
 
 
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 1014)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 1015)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-!
+! acc allowed for loop optimization,
+! checks for adjustment of mixing length to the Prandtl mixing length removed
 !
 ! Former revisions:
@@ -481,10 +482,16 @@
        ENDIF
     ENDIF
-    IF ( loop_optimization /= 'noopt'  .AND.  loop_optimization /= 'cache' &
-         .AND.  loop_optimization /= 'vector' )  THEN
-       message_string = 'illegal value given for loop_optimization: "' // &
-                        TRIM( loop_optimization ) // '"'
-       CALL message( 'check_parameters', 'PA0013', 1, 2, 0, 6, 0 )
-    ENDIF
+
+    SELECT CASE ( TRIM( loop_optimization ) )
+
+       CASE ( 'acc', 'cache', 'noopt', 'vector' )
+          CONTINUE
+
+       CASE DEFAULT
+          message_string = 'illegal value given for loop_optimization: "' // &
+                           TRIM( loop_optimization ) // '"'
+          CALL message( 'check_parameters', 'PA0013', 1, 2, 0, 6, 0 )
+
+    END SELECT
 
 !
@@ -1394,12 +1401,8 @@
     IF ( bc_e_b == 'neumann' )  THEN
        ibc_e_b = 1
-       IF ( adjust_mixing_length  .AND.  prandtl_layer )  THEN
-          message_string = 'adjust_mixing_length = TRUE and bc_e_b = "neumann"'
-          CALL message( 'check_parameters', 'PA0055', 0, 1, 0, 6, 0 )
-       ENDIF
     ELSEIF ( bc_e_b == '(u*)**2+neumann' )  THEN
        ibc_e_b = 2
-       IF ( .NOT. adjust_mixing_length  .AND.  prandtl_layer )  THEN
-          message_string = 'adjust_mixing_length = FALSE and bc_e_b = "' // &
+       IF ( prandtl_layer )  THEN
+          message_string = 'adjust mixing length = FALSE and bc_e_b = "' // &
                            TRIM( bc_e_b ) // '"'
           CALL message( 'check_parameters', 'PA0056', 0, 1, 0, 6, 0 )
Index: /palm/trunk/SOURCE/coriolis.f90
===================================================================
--- /palm/trunk/SOURCE/coriolis.f90	(revision 1014)
+++ /palm/trunk/SOURCE/coriolis.f90	(revision 1015)
@@ -4,6 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
-!
+! accelerator version (*_acc) added
 !
 ! Former revisions:
@@ -36,5 +35,5 @@
 
     PRIVATE
-    PUBLIC coriolis
+    PUBLIC coriolis, coriolis_acc
 
     INTERFACE coriolis
@@ -42,4 +41,8 @@
        MODULE PROCEDURE coriolis_ij
     END INTERFACE coriolis
+
+    INTERFACE coriolis_acc
+       MODULE PROCEDURE coriolis_acc
+    END INTERFACE coriolis_acc
 
  CONTAINS
@@ -116,4 +119,94 @@
 
     END SUBROUTINE coriolis
+
+
+!------------------------------------------------------------------------------!
+! Call for all grid points - accelerator version
+!------------------------------------------------------------------------------!
+    SUBROUTINE coriolis_acc( component )
+
+       USE arrays_3d
+       USE control_parameters
+       USE indices
+       USE pegrid
+
+       IMPLICIT NONE
+
+       INTEGER ::  component, i, j, k
+
+
+!
+!--    Compute Coriolis terms for the three velocity components
+       SELECT CASE ( component )
+
+!
+!--       u-component
+          CASE ( 1 )
+             !$acc  kernels present( nzb_u_inner, tend, v, vg, w )
+             !$acc  loop
+             DO  i = nxlu, nxr
+                DO  j = nys, nyn
+                   !$acc loop vector( 32 )
+                   DO  k = 1, nzt
+                      IF  ( k > nzb_u_inner(j,i) )  THEN
+                         tend(k,j,i) = tend(k,j,i) + f  *    ( 0.25 *          &
+                                      ( v(k,j,i-1) + v(k,j,i) + v(k,j+1,i-1) + &
+                                        v(k,j+1,i) ) - vg(k) )                 &
+                                                - fs *    ( 0.25 *             &
+                                      ( w(k-1,j,i-1) + w(k-1,j,i) + w(k,j,i-1) &
+                                        + w(k,j,i)   )                         &
+                                                             )
+                      ENDIF
+                   ENDDO
+                ENDDO
+             ENDDO
+             !$acc end kernels
+
+!
+!--       v-component
+          CASE ( 2 )
+             !$acc  kernels present( nzb_v_inner, tend, u, ug )
+             !$acc  loop
+             DO  i = nxl, nxr
+                DO  j = nysv, nyn
+                   !$acc loop vector( 32 )
+                   DO  k = 1, nzt
+                      IF  ( k > nzb_v_inner(j,i) )  THEN
+                         tend(k,j,i) = tend(k,j,i) - f *     ( 0.25 *          &
+                                      ( u(k,j-1,i) + u(k,j,i) + u(k,j-1,i+1) + &
+                                        u(k,j,i+1) ) - ug(k) )
+                      ENDIF
+                   ENDDO
+                ENDDO
+             ENDDO
+             !$acc end kernels
+
+!
+!--       w-component
+          CASE ( 3 )
+             !$acc  kernels present( nzb_w_inner, tend, u )
+             !$acc  loop
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   !$acc loop vector( 32 )
+                   DO  k = 1, nzt
+                      IF  ( k > nzb_w_inner(j,i) )  THEN
+                         tend(k,j,i) = tend(k,j,i) + fs * 0.25 *             &
+                                      ( u(k,j,i) + u(k+1,j,i) + u(k,j,i+1) + &
+                                        u(k+1,j,i+1) )
+                      ENDIF
+                   ENDDO
+                ENDDO
+             ENDDO
+             !$acc end kernels
+
+          CASE DEFAULT
+
+             WRITE( message_string, * ) ' wrong component: ', component
+             CALL message( 'coriolis', 'PA0173', 1, 2, 0, 6, 0 )
+
+       END SELECT
+
+    END SUBROUTINE coriolis_acc
 
 
Index: /palm/trunk/SOURCE/cpu_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/cpu_statistics.f90	(revision 1014)
+++ /palm/trunk/SOURCE/cpu_statistics.f90	(revision 1015)
@@ -4,9 +4,12 @@
 ! Current revisions:
 ! -----------------
-! output of handling of ghostpoint exchange
+! output of accelerator board information
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 683 2011-02-09 14:25:15Z raasch
+! output of handling of ghostpoint exchange
 !
 ! 622 2010-12-10 08:08:13Z raasch
@@ -135,8 +138,12 @@
                           numprocs * threads_per_task, pdims(1), pdims(2), &
                           threads_per_task
+       IF ( num_acc_per_node /= 0 )  WRITE ( 18, 108 )  num_acc_per_node
+       WRITE ( 18, 110 )
 #else
        WRITE ( 18, 100 )  TRIM( run_description_header ),        &
                           numprocs * threads_per_task, 1, 1, &
                           threads_per_task
+       IF ( num_acc_per_node /= 0 )  WRITE ( 18, 109 )  num_acc_per_node
+       WRITE ( 18, 110 )
 #endif
        DO
@@ -276,13 +283,5 @@
 
 100 FORMAT (A/11('-')//'CPU measures for ',I5,' PEs (',I5,'(x) * ',I5,'(y', &
-            &') tasks *',I5,' threads):'/ &
-             &'----------------------------------------------------------', &
-             &'------------'//&
-            &'place:                        mean        counts      min  ', &
-             &'     max       rms'/ &
-            &'                           sec.      %                sec. ', &
-             &'     sec.      sec.'/  &
-            &'-----------------------------------------------------------', &
-             &'-------------------')
+            &') tasks *',I5,' threads):')
 
 101 FORMAT (/'special measures:'/ &
@@ -296,4 +295,14 @@
 106 FORMAT (/'Exchange of ghostpoints via MPI_ISEND/MPI_IRECV')
 107 FORMAT (//)
+108 FORMAT ('Accelerator boards per node: ',I2)
+109 FORMAT ('Accelerator boards: ',I2)
+110 FORMAT ('----------------------------------------------------------',   &
+            &'------------'//&
+            &'place:                        mean        counts      min  ', &
+            &'     max       rms'/ &
+            &'                           sec.      %                sec. ', &
+            &'     sec.      sec.'/  &
+            &'-----------------------------------------------------------', &
+            &'-------------------')
 
  END SUBROUTINE cpu_statistics
